'Compilable Example:
#Compiler PBWin 9, PBWin 10
#Compile Exe
#Dim All
%Unicode=1
#Include "Win32API.inc"

#Resource Icon xup, "up.ico"
#Resource Icon xdown, "down.ico"
#Resource Icon xbelow, "below.ico"

%IDC_Toolbar = 500
%IDC_Button  = 501

Global hDlg,hLst As Dword, wIcon,hIcon As Long

Function PBMain() As Long
   Dialog Default Font "Tahoma", 10, 1
   Dialog New Pixels, 0, "Dynamic Icon Colors",,,350,100, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "xup"
   Control Add Button, hDlg, %IDC_Button,"New Color", 20,65,200,25
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Randomize Timer
         wIcon = 32 : hIcon = 32
         CreateToolbarAndImageList
      Case %WM_Command
         If CB.Ctl = 501 Then
          CreateToolbarAndImageList
         End If
   End Select
End Function

Sub CreateToolbarAndImageList
   Local iColor As Long 
   iColor = RGB(Rnd(0,255) , Rnd(0,255), Rnd(0,255))

   ImageList Kill hLst
   Control Kill hDlg, %IDC_Toolbar

   ImageList New Icon wIcon,hIcon,32,10 To hLst
   ImageList Add Icon hLst, "xup"
   ImageList Add Icon hLst, "xdown"
   ImageList Add Icon hLst, "xbelow"
   ImageList Add Icon hLst, CreateColorIcon(iColor,wIcon,hIcon,1)
   ImageList Add Icon hLst, CreateColorIcon(iColor,wIcon,hIcon,2)

   'ImageList Add Icon hLst, CreateColorIcon(iColor,wIcon,hIcon,3)
   Local hNewIcon As Long
   Static nCount As Long
   Incr nCount
   hNewIcon = CreateColorIcon(iColor,wIcon,hIcon,3)
   'ModifyIcon(hNewIcon, nCount)
   ModifyIcon_Font(hNewIcon, Format$(nCount), "Arial,12")
   ImageList Add Icon hLst, hNewIcon
   
   Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Flat Or %WS_Border Or %WS_Child
   Toolbar Set ImageList hDlg, %IDC_Toolbar, hLst, 0    'attach imagelist
   Toolbar Add Button  hDlg, %IDC_Toolbar, 4, 600,  %TbStyle_Button, "Up"
   Toolbar Add Button  hDlg, %IDC_Toolbar, 5, 600,  %TbStyle_Button, "Down"
   Toolbar Add Button  hDlg, %IDC_Toolbar, 6, 600,  %TbStyle_Button, "Below"
End Sub

Function CreateColorIcon(iColor As Long, w As Long, h As Long, ResIndex As Long) As Dword
   Local B As Bitmap, P As IconInfo, hBMPXor, hBMPAnd As Dword, bmp$
   Local bgColor, x,y, iPos, i As Long, PixelPtr As Long Ptr

   bgColor = GetSysColor(%Color_BtnFace)

   'Create an XOR bitmap using the bitstring in bmp$
   Graphic Bitmap New w,h To hBMPXOR
   Graphic Attach hBMPXOR, 0
   Graphic Clear bgColor
   Graphic ImageList(0,0),hLst, ResIndex, 0, %ILD_Normal

   'replacement for previous Paint
   Graphic Get Bits To bmp$
   x = Cvl(bmp$,1) : y = Cvl(bmp$,5) : PixelPtr = StrPtr(bmp$) + 8
   For i = 1 To w*h
      If @PixelPtr <> Bgr(bgColor) Then @PixelPtr = Bgr(iColor)
      Incr PixelPtr
   Next i
   Graphic Set Bits bmp$


   'create the MASK bitmap variable information
   Dim Mask(1 To w*h/8) As Static Byte
   B.bmType = 0           :   B.bmWidth = w    :   B.bmHeight = h
   B.bmWidthBytes = w/8   :   B.bmPlanes = 1   :   B.bmBitsPixel = 1
   B.bmBits = VarPtr(Mask(1))
   hBMPAND = CreateBitmapIndirect(B)

   'fill in the ICONINFO variable and create the icon (.xHotSpot/.yHotSpot are ignored)
   P.fIcon = %True
   P.hbmColor = hBMPXOR
   P.hbmMask = hBMPAND
   Function = CreateIconIndirect (P)
End Function

'----------------------------------------------------------------
Sub ModifyIcon(hIcon As Dword, ByVal lCount As Long)
'----------------------------------------------------------------
    ' Draw a number (lCount) over the icon (hIcon), then create a
    '  new icon from the resulting image and return a handle to it
    
    Local uInfo As ICONINFO, lRes As Long
    Local hMemDC As Dword, hOldBMP As Dword, sText As String
    Local hNewIcon As Dword, rectDraw As RECT, uBitmap As Bitmap

    lRes = GetIconInfo(hIcon, uInfo)
    If lRes <> 0 Then
        ' Call succeeded
        hMemDC = CreateCompatibleDC(ByVal %Null)
        If hMemDC = 0 Then
            MsgBox "CreateCompatibleDC failed : " & Str$(hMemDC), %MB_TASKMODAL
        Else
            ' Get info for the bitmap
            GetObject uInfo.hbmColor, SizeOf(uBitmap), uBitmap
            ' and setup RECT
            rectDraw.nLeft = 0
            rectDraw.nTop = 0
            rectDraw.nRight = uBitmap.bmWidth - 1
            rectDraw.nBottom = uBitmap.bmHeight - 1
            ' Get our bitmap ready to draw on
            hOldBMP = SelectObject(hMemDC, uInfo.hbmColor)
            ' Format the count
            sText = Format$(lCount, "#0")
            ' Draw it
            'lRes = DrawText(hMemDC, ByCopy sText, Len(sText), rectDraw, %DT_CENTER Or %DT_VCENTER Or %DT_SINGLELINE)
            lRes = DrawText(hMemDC, ByCopy sText, Len(sText), rectDraw, %DT_RIGHT Or %DT_TOP Or %DT_SINGLELINE)
            ' Put old bitmap back
            SelectObject hMemDC, hOldBMP
            ' Create the new icon from the modified structure
            hNewIcon = CreateIconIndirect(uInfo)

            If hNewIcon <> 0 Then
                ' Worked ok - delete the old icon
                DestroyIcon hIcon
                ' And pass the handle to the new one back
                hIcon = hNewIcon
            Else
                MsgBox "CreateIconIndirect failed", %MB_TASKMODAL
            End If

            ' Clean up the memory DC
            DeleteDC hMemDC
        End If
        
        ' Note that we also need to clean up the 2 bitmaps we got in the structure
        DeleteObject uInfo.hbmMask
        DeleteObject uInfo.hbmColor
        
    Else
        MsgBox "GetIconInfo failed", %MB_TASKMODAL
    End If
End Sub


'----------------------------------------------------------------
Function ModifyIcon_Font(hIcon As Dword, ByVal cText As String, ByVal cFont As String) As Long
'----------------------------------------------------------------
    ' Draw a bit of text on the icon supplied as the hIcon handle
    ' and set the font.  Font is supplied as fontname,pointsize,BIU  where B=bold, I= Italic and U=Underlined
    ' Makes use of the firefly makefont function, but could be converted to use the PBFORMs one or any other
    ' which works in a similar fashion.
    ' ALL of the main original code was created by Peter Jinks and placed on the PowerBASIC forum
    ' him - for which I am very grateful!
    
    Local uInfo As ICONINFO
    Local lRes As Long
    Local hMemDC As Dword
    Local hOldBMP As Dword
    Local hNewIcon As Dword
    Local rectDraw As Rect
    Local uBitmap As Bitmap
    Local hOldFont As Dword
    Local cName As String
    Local cStyle As String  
    Local nPoint As Long
    Static cOldFont As String 
    If cOldFont = "" Then
    	' We use this is the user does not specify.  If they do, we remember it!
    	cOldFont = "Arial,16"
    End If
    
    If Len(cFont) Then cOldFont = cFont
	cName = Parse$(cOldFont,",",1)							' Get the font name
	cStyle = UCase$(Parse$(cOldFont,",",3))					' Get the style bits (BI or I in a string)
	nPoint = Min(Max(Val(Parse$(cOldFont,",",2)),8),36)    	' Get the point size between 8 and 36
    'MsgBox Using$("Font = [&], #_, [&]", cName, nPoint, cStyle)
    lRes = GetIconInfo(hIcon, uInfo) 
    If lRes = 0 Then
    	Function = %False
    	Exit Function
    End If
    ' Call succeeded
    hMemDC = CreateCompatibleDC(ByVal %Null)
    If hMemDC = 0 Then
    	Function = %False
    	Exit Function
    End If
    
    Local hFont As Long
    Font New Parse$(cFont, ",", 1), Val(Parse$(cFont, ",", 2)) To hFont

    ' Get info for the bitmap
    GetObject uInfo.hbmColor, SizeOf(uBitmap), uBitmap
    ' and setup RECT
    rectDraw.nLeft = 0 : rectDraw.nTop = 0 : rectDraw.nRight = uBitmap.bmWidth - 1 : rectDraw.nBottom = uBitmap.bmHeight - 0
    ' Get our bitmap ready to draw on
    hOldBMP = SelectObject(hMemDC, uInfo.hbmColor)
    ' Set the font
    'hOldFont = SelectObject(hMemDC, FF_MakeFontEx(cName,nPoint,Tally(cStyle,"B"),Tally(cStyle,"I"),Tally(cStyle,"U"),%False))
    hOldFont = SelectObject(hMemDC, hFont)
    'lRes = DrawText(hMemDC, ByCopy cText, Len(cText), rectDraw, %DT_CENTER Or %DT_VCENTER Or %DT_SINGLELINE)
    lRes = DrawText(hMemDC, ByCopy cText, Len(cText), rectDraw, %DT_RIGHT Or %DT_TOP Or %DT_SINGLELINE)
    ' Put old bitmap back
    SelectObject hMemDC, hOldBMP
    ' put back the old font and delete the new one
    hOldFont = SelectObject(hMemDC, hOldFont)
    DeleteObject hOldFont
    ' Create the new icon from the modified structure
    hNewIcon = CreateIconIndirect(uInfo)
    If hNewIcon <> 0 Then
        ' Worked ok - delete the old icon
        DestroyIcon hIcon
        ' And pass the handle to the new one back
        hIcon = hNewIcon
        Function = %True
    Else
        Function = %False
    End If
    ' Clean up the memory DC
    DeleteDC hMemDC
    
    ' Note that we also need to clean up the 2 bitmaps we got in the structure
    DeleteObject uInfo.hbmMask
    DeleteObject uInfo.hbmColor
        
End Function

